# -*- coding: utf-8 -*-
# (c) Copyright 2017 Daniel Campos <danielcampos@avanzosc.es> - Avanzosc S.L.
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl).

from openerp.osv import orm


class MrpProductProduce(orm.TransientModel):
    _inherit = "mrp.product.produce"

    def _reserve_move(self, cr, uid, move, context):
        """ reserves products from a counterpart picking of a move
        @param product: Product to check to reserve
        @return: reserved stock_picking id
        """
        if move:
            stock_move_obj = self.pool['stock.move']
            picking_obj = self.pool['stock.picking']
            st_moves = stock_move_obj.search(
                cr, uid, [('product_id', '=', move.product_id.id),
                          ('location_id', '=', move.location_dest_id.id),
                          ('state', '=', 'confirmed')], order='date_expected',
                context=context)
            pickings = []
            for move_to in stock_move_obj.browse(cr, uid, st_moves, context):
                if move_to.picking_id.id not in pickings:
                    pickings.append(move_to.picking_id.id)
            # TO DO Chained location move_dest_id
            for picking_id in pickings:
                picking_obj.action_assign(cr, uid, [picking_id])
        return pickings

    def do_produce(self, cr, uid, ids, context=None):
        res = super(MrpProductProduce, self).do_produce(cr, uid, ids, context)
        production_obj = self.pool['mrp.production']
        production = False
        if context and 'active_id' in context:
            production_id = context.get('active_id', False)
            production = production_obj.browse(cr, uid, production_id, context)
        picking_list = []
        if production:
            for move in production.move_created_ids2:
                picking_list += self._reserve_move(cr, uid, move, context)
        return res
