# -*- coding: utf-8 -*-
# (c) Copyright 2017 Daniel Campos <danielcampos@avanzosc.es> - Avanzosc S.L.
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl).

from openerp.osv import orm


class StockChangeProductQty(orm.TransientModel):
    _inherit = "stock.change.product.qty"


    def _reserve_move(self, cr, uid, move_id, context):
        """ reserves products from a counterpart picking of a move
        @param product: Product to check to reserve
        @return: reserved stock_picking id
        """
        move_obj = self.pool['stock.move']
        if move_id:
            move = move_obj.browse(cr, uid, move_id, context)
            picking_obj = self.pool['stock.picking']
            st_moves = move_obj.search(
                cr, uid, [('product_id', '=', move.product_id.id),
                          ('location_id', '=', move.location_dest_id.id),
                          ('state', '=', 'confirmed')], order='date_expected',
                context=context)
            pickings = []
            for move_to in move_obj.browse(cr, uid, st_moves, context):
                if move_to.picking_id.id not in pickings:
                    pickings.append(move_to.picking_id.id)
            # TO DO Chained location move_dest_id
            for picking_id in pickings:
                picking_obj.action_assign(cr, uid, [picking_id])
        return pickings

    def change_product_qty(self, cr, uid, ids, context=None):
        res = super(StockChangeProductQty, self).change_product_qty(
            cr, uid, ids, context)
        move_obj = self.pool['stock.move']
        if context and 'active_id' in context and \
                context['active_model'] == 'product.product':
            move_id = move_obj.search(
                cr, uid, [('product_id', '=', context['active_id']),
                          ('state', '=', 'done')], context=context)[-1]
            self._reserve_move(cr, uid, move_id, context)
        return res
